/***************************************************************************
Name: JSView
Version: 1.4
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/





var jsvOptions = {

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");
	},

	getSt: function(name) {
		return document.getElementById("jsview-bundle").getString(name);
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	framePrefHelp: function() {
		alert(this.getSt('jsview.FrPrfHlp'));
	},

	clickHelp: function() {
		alert(this.getSt('jsview.ClickHelp'));
	},

	behavior: function() {
		var one = this.getSt('jsview.OpenNewWin');
		var two = this.getSt('jsview.OpenBlur');
		var three = this.getSt('jsview.OpenFocus');
		var four = this.getSt('jsview.External');
		var attrib = document.getElementById('chooseBehavior');
		var current = attrib.value;

		if (current == one) {
			attrib.value = two;
		} else if (current == two) {
			attrib.value = three;
		} else if (current == three) {
			attrib.value = four;
		} else if (current == four || current == '') {
			attrib.value = one;
		} else {
			attrib.value = one;
		}
	},

	onDialogLoad: function() {
		var prefs = this.getPrefs();

		document.getElementById('disableContext').checked = prefs.getBoolPref('disableContext');
		document.getElementById('disableVPS').checked = prefs.getBoolPref('disableVPS');
		document.getElementById('disableStatus').checked = prefs.getBoolPref('disableStatus');
		document.getElementById('disableToolsOptions').checked = prefs.getBoolPref('disableToolsOptions');
		document.getElementById('framePref').checked = prefs.getBoolPref('framePref');
		document.getElementById('activateOnclick').checked = prefs.getBoolPref('activateOnclick');
		document.getElementById('fileSize').checked = prefs.getBoolPref('fileSize');

		document.getElementById('applocation').value = prefs.getCharPref('extapp');

		var bhvr = document.getElementById('chooseBehavior');
		var bhvrVal = prefs.getCharPref('chooseBehavior');
		if (bhvrVal=='chrome://jsview/locale/jsview.properties') {
			bhvr.value = this.getSt('jsview.OpenNewWin');
		} else {
			bhvr.value = bhvrVal;
		}
	},

	onDialogAccept: function() {
		var win = this.getMainWin();
		var prefs = this.getPrefs();

		var vps = document.getElementById('disableVPS');
		prefs.setBoolPref('disableVPS',vps.checked);
		win.document.getElementById('jsview-source').setAttribute('hidden',vps.checked);

		var checkone = document.getElementById("disableContext");
		var contextdiff = (checkone.checked!=prefs.getBoolPref("disableContext")) ? "yes" : "no";
		prefs.setBoolPref("disableContext", checkone.checked);

		var checktwo = document.getElementById("disableStatus");
		var statusdiff = (checktwo.checked!=prefs.getBoolPref("disableStatus")) ? "yes" : "no";
		prefs.setBoolPref("disableStatus", checktwo.checked);

		var checkfive = document.getElementById("disableToolsOptions");
		var toolsmenudiff = (checkfive.checked!=prefs.getBoolPref("disableToolsOptions")) ? "yes" : "no";
		prefs.setBoolPref("disableToolsOptions", checkfive.checked);

		var checkeight = document.getElementById("framePref");
		prefs.setBoolPref("framePref", checkeight.checked);

		var checknine = document.getElementById("fileSize");
		prefs.setBoolPref("fileSize", checknine.checked);

		var click = document.getElementById('activateOnclick');
		if (click.checked) {
			win.document.getElementById('jsview-status').setAttribute('onclick','jsview.jsviewStatus();');
		} else {
			win.document.getElementById('jsview-status').removeAttribute('onclick');
		}
		prefs.setBoolPref('activateOnclick',click.checked);

		var txtone = document.getElementById('chooseBehavior');
		if (txtone.value==this.getSt('jsview.OpenNewWin')) {
			prefs.setCharPref('chooseBehavior','chrome://jsview/locale/jsview.properties');
		} else {
			prefs.setCharPref("chooseBehavior", txtone.value);
		}

		var contextmenu = win.document.getElementById('contentAreaContextMenu');
		var jscontextmenu = win.document.getElementById('jsview-context-menu');
		var csscontextmenu = win.document.getElementById('cssview-context-menu');
		if (contextdiff == 'yes') {
			if (!checkone.checked) {
				contextmenu.addEventListener("popupshowing", win.jsviewListen.CL, false);
			} else {
				contextmenu.removeEventListener("popupshowing", win.jsviewListen.CL, false);
				jscontextmenu.setAttribute('hidden',true);
				csscontextmenu.setAttribute('hidden',true);
			}
		}


		var status = win.document.getElementById('jsview-status');
		var statuspopup = win.document.getElementById('jsview-status-popup');
		if (statusdiff == "yes") {
			if (!checktwo.checked) {
				statuspopup.addEventListener("popupshowing", win.jsviewListen.SL, false);
				status.setAttribute('hidden',false);
			} else {
				statuspopup.removeEventListener("popupshowing", win.jsviewListen.SL, false);
				status.setAttribute('hidden',true);
			}
		}

		var toolsmenu = win.document.getElementById('jsview-options');
		if (toolsmenudiff == "yes") {
			if (!checkfive.checked) {
				toolsmenu.setAttribute('hidden',false);
			} else {
				toolsmenu.setAttribute('hidden',true);
			}
		}
	},

	chooseProgram: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
        		createInstance(nsIFilePicker);
		fp.init(window, this.getSt('jsview.SelectExt'), nsIFilePicker.modeOpen);
		fp.appendFilter(this.getSt('jsview.Programs'),"*.exe");
		fp.appendFilter(this.getSt('jsview.AllFiles'),"*.*");
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = this.getPrefs();
			prefs.setCharPref('extapp',fp.file.path);
			document.getElementById('applocation').value = fp.file.path;
		}
	}
};